﻿using System.ComponentModel;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;

namespace gridError
{
    public partial class Form1 : Form
    {
        BindingList<DataPoint> data;
        public Form1()
        {
            InitializeComponent();
            InitializeData();
        }

        private void InitializeData()
        {
            data = new BindingList<DataPoint>();
            for (int i = 0; i < 100; i++)
            {
                var newDataPoint = new DataPoint()
                {
                    Name = i,
                    Even = i % 2 == 0,                    
                };
                data.Add(newDataPoint);
            }
            ultraGrid1.SetDataBinding(data, null);
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var ov = layout.Override;
            var band = layout.Bands[0];

            band.ColumnFilters["Even"].FilterConditions.Add(FilterComparisionOperator.Equals, 0);
            ov.FilterUIType = FilterUIType.FilterRow;
        }
    }

    public class DataPoint : IDataErrorInfo
    {
        public int Name { get; set; }
        public bool Even { get; set; }
       
        string IDataErrorInfo.this[string propertyName]
        {
            get
            {
                if (this.Even)
                    Debug.WriteLine("If we get here, it means someone asked for the IDataErrorInfo for a filtered-out row.");
                
                return string.Empty;
            }
        }

        string IDataErrorInfo.Error
        {
            get
            {
                if (this.Even)
                    Debug.WriteLine("If we get here, it means someone asked for the IDataErrorInfo for a filtered-out row.");

                return string.Empty;
            }
        }
    }
}
